<?php
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

include "fefunctions.php";
?>
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <title>HP Insight Diagnostics</title>
  
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
  <script language=Javascript>
  
  //function validate(parameter, parameterName, parameterDefault)
function validate(parameter, parameterName)
  {
    var val = new Number(parameter);
    var oStringParameterName = new String(parameterName);
    
    if((!oStringParameterName.localeCompare("->BlocksPerAccess")) && (val > 250))
    {
        //alert(" Please reenter the value from 1 to 250. Your entered value is  " + parameter );
        alert("<?php echo TR("MSG_ENTER_FROM_1_TO_250 "); ?>" + parameter );
        location.reload();
        location.select();
    }

    if(val != parameter || val < 0 || (parameter.indexOf(".") != -1))
    {
      alert("<?php echo TR("MSG_NUMERIC_ONLY"); ?>");
      location.reload();
    }
  }

  function nobackslashes(parameter)
  {
    for (i = 0; i < parameter.length; i++)
    {
      if (parameter.charCodeAt(i)==92)
      {
        alert("<?php echo TR("MSG_NO_BACKSLASHES"); ?>");
        location.reload();
      }

    }
  }
  </script>
</head>
<body>
<FORM name='parametersForm' action='parameters.php' method=post>
<input type=hidden name=begin>
<table>
<tr valign=top><td class='head'><?php echo TR("MSG_TEST_PARAMETERS"); ?></td></tr>
</table>


<?php

$device = $_REQUEST["device"];
$test = $_REQUEST["test"];

if($HTTP_POST_VARS["paramSubmit"] == "1")
{
  $dom = new DomDocument("<formData/>");

  $updateParam = false;
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = xpath_new_context($idXml->document_element());

  // initialize everything to 'off' so we pass the unchecked parameters
  $parameters = @xpath_eval($idXpath, "/diagOutput/category/device[@name='".$device."']/test[@name='".$test."']/parameter");
  $num_parameters = count($parameters->nodeset);
  $formData = $dom->document_element();
  for ($p=0; $p < $num_parameters; $p++)
  {
    $parameterNode = $parameters->nodeset[$p];
    if ($parameterNode->get_attribute("type") == "bool")
    {
	    $parameterName = $parameterNode->get_attribute("name");
	    $parameterDefault = $parameterNode->get_attribute("defaultValue");    
      $formData->set_attribute($parameterName,"off");
    }
  }
  
  while(list($key, $value) = each($HTTP_POST_VARS))	// get each posted variable and store the name in $key and the value in $value
  {
    if(strstr($key, "->") && $value != "") // if it's a parameter
	  {
	    $parameterName = substr($key, strpos($key,">")+1);
      $formData->set_attribute($parameterName,$value);
	    $updateParam = true;
	  }
  }
  if($updateParam)
  {
    $tests = xpath_eval($idXpath, "/diagOutput/category/device[@name='".$device."']/test[@name='".$test."']");
	  $testNode = &$tests->nodeset[0];
	
    $parameters = xpath_eval($idXpath, "/diagOutput/category/device[@name='".$device."']/test[@name='".$test."']/parameter");
	  $parameter = $parameters->nodeset[0];

    $formDatas = xpath_eval($idXpath, "/diagOutput/category/device[@name='".$device."']/test[@name='".$test."']/formData");
    if (count($formDatas->nodeset))
	  {
	    $oldFormData = $formDatas->nodeset[0];
	    $oldFormData->replace_node($formData);
	  }
	  else
	  {		
	    // save the users paramters
	    $testNode->insert_before($formData, $parameter);
	  }
	  $_SESSION["idResult"] = $idXml->dump_mem();

      // debug
      //$idXml->dump_file($_SESSION["diagsDirectory"] . "param.xml");
  }

  // if the 'Begin Testing' button was pressed
  // The 'begin' parameter is here because we have to make sure that 
  // the parameters page is done with the idResult session vari able
  // so we don't lock up - see the comment for the SubmitParametersFirst
  // function on the custom.php page for more understanding
  if ($HTTP_POST_VARS["begin"] == "1") 
  {
    printf("\n<script language='Javascript'>\n");
	  printf("parent.parent.frames.dataFrame3.BeginTesting();\n");
    printf("</script>\n");
  }
  else
  { 
    
    printf("\n<script language='Javascript'>\n");
    printf("window.location='parameters.php?device='+parent.parent.frames.dataFrame3.document.diagRunForm.device.value");
    printf("+'&test='+parent.parent.frames.dataFrame3.document.diagRunForm.test.value;\n");
    printf("</script>\n");
         
  }
}
else
{
  printf("<input type=hidden name=device value=%s>\n<input type=hidden name=test value=%s>\n<table>\n", $device, $test);
  $idXml = new DomDocument($_SESSION["idResult"]);
  //echo htmlentities($idXml->html_dump_mem());
  $idXpath = @xpath_new_context($idXml->document_element());
  $formDatas = @xpath_eval($idXpath, "/diagOutput/category/device[@name='".$device."']/test[@name='".$test."']/formData");
  $parameterSearch = "/diagOutput/category/device[@name='" . $device . "']/test[@name='" . $test . "']/parameter";
  $parameters = @xpath_eval($idXpath, $parameterSearch);

  $num_parameters = count($parameters->nodeset);
  if ($num_parameters)
  {
    $parameterChild = $parameters->nodeset[0];
	  $testNode = $parameterChild->parent_node();
	  $deviceNode = $testNode->parent_node();
    $deviceCaption = $deviceNode->get_attribute("caption");
    $deviceDescription = $deviceNode->get_attribute("description");
    $testCaption = $testNode->get_attribute("caption");
	  $testDescription = $testNode->get_attribute("description");

	  printf(" <tr>\n  <td colspan='2' class='head'>%s</td>\n </tr>\n", $testCaption);
	  printf(" <tr>\n  <td colspan='2' class='subhead'>%s</td>\n </tr>\n", $deviceCaption);
    printf(" <tr>\n  <td colspan='2' class='subhead'>%s</td>\n </tr>\n", $deviceDescription);
	  printf(" <tr>\n  <td colspan='2' class='subhead'><br>&nbsp;&nbsp;%s</td>\n </tr>\n", $testDescription);
    
    for ($p=0; $p < $num_parameters; $p++)
    {
      $parameterNode = $parameters->nodeset[$p];
	    $parameterName = $parameterNode->get_attribute("name");
	    $parameterCaption = $parameterNode->get_attribute("caption");
	    $parameterDesc = $parameterNode->get_attribute("description");
	    $parameterDefault = $parameterNode->get_attribute("defaultValue");
	    $parameterType = $parameterNode->get_attribute("type");

	    if (count($formDatas->nodeset)) // if previous posted parameters were set
	    { // get them
        $foundParam = false;
	      $formData = $formDatas->nodeset[0];
	  	  $attributesArr = $formData->attributes();
        for( $j=0; $j < count($attributesArr); $j++)
		    {
		      if ($parameterName == $attributesArr[$j]->node_name())
          {
		        $parameterDefault =  $attributesArr[$j]->get_content();
            $foundParam = true;
          }
		    }
        if ($parameterType == "bool" && !$foundParam) // if the checkbox was un checked
          $parameterDefault = "0"; // we have to make sure we save that state
	    }
      
	    printf(" <tr>\n  <td align='left' nowrap>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s</td>", $parameterCaption);

      if ($parameterType == "bool")
	    {
	      printf(" <td><input type='checkbox' name='->%s' title='%s'", $parameterName, $parameterDesc);

	      if ($parameterDefault == "1" || $parameterDefault == "on")
	        printf(" checked");
	      printf("></td>\n");
	    }
      else if ($parameterType == "ENUM")
	    {
	      $textItemXpath = @xpath_new_context($parameterNode);
	      $textItems = @xpath_eval($textItemXpath, "/TextItem");
	      $num_textItems = count($textItems->nodeset);
	      printf("<td>\n    <select name='->%s'>\n", $parameterName);
	      for ($t=0; $t<$num_textItems; $t++)
	      {
	        $textItemNode = $textItems->nodeset[$t];
	        $textItemName = $textItemNode->get_attribute("name");
		      $textItemCaption = $textItemNode->get_attribute("caption");
		      printf("      <option value='%s'", $textItemName);
		       if ($parameterDefault ==  $textItemName)
		         printf(" selected");
		      printf(">%s</option>\n", $textItemCaption);
	      }
	      printf("    </select>\n  </td>");
	    }
	    else // simple text
	    {
	      printf("<td><input type='text' name='->%s' title='%s' value='%s'", $parameterName, $parameterDesc, $parameterDefault);
        if ($parameterType == "int")
           printf(" onchange='validate(this.value, this.name);'\n");
        else
           printf(" onchange='nobackslashes(this.value);'");
        printf("></td>\n");
	    }
      printf(" </tr>\n");
    }
  }
  printf("</table>\n<input type=hidden name=paramSubmit value='1'>\n</form>\n");
}
?>
<script language="Javascript" src="norightclick.js"></script></body>
</html>
